
var calc = function (paramsObj) {

  //计算类
  //symbol 1= 加 2=减 3=乘 4=除
  let getCalculationModel = function (leftNum, rightNum, resultNum, symbol, emptyNum) {
    return {
      leftNum: leftNum,
      rightNum: rightNum,
      resultNum: resultNum,
      symbol: symbol,// 1= 加 2=减 3=乘 4=除
      emptyNum: emptyNum// 第几个数是填空
    }
  }

  //获取随机数 1到max
  let getRandom = function (max, min) {
    //var max = 10;//上限
    //var min = 1; //下限
    var rand = parseInt(Math.random() * (max - min + 1) + min);
    return rand;
  }

  //---------加法-----------//
  //获取加法对象List
  let getAddInfoList = function () {
    let numFormula = new Object();//数式
    numFormula["Data"] = [];
    for (var i = 0; i < paramsObj.total; i++) {
      //numFormula.push(getAddInfo());
      numFormula["Data"].push(getAddInfo());// = getAddInfo();
    }
    return numFormula
  }
  //获取加法对象
  let getAddInfo = function () {
    if (paramsObj.strategy == 1) {//加数不可以超过
      var leftNum = getRandom(paramsObj.range - 1, 1);
      var rightNum = getRandom(paramsObj.range - 1, 1);
      var resultNum = leftNum + rightNum;
      var symbol = 1;
      var emptyNum = 3;
      if (paramsObj.empty == 1) {
        emptyNum = 3;
      }
      else {
        emptyNum = getRandom(3, 1);
      }
      return getCalculationModel(leftNum, rightNum, resultNum, symbol, emptyNum);
    }
    else {//结果不可超过
      var resultNum = getRandom(paramsObj.range, 1);
      var leftNum = getRandom(resultNum, 1);
      var rightNum = resultNum - leftNum;
      var symbol = 1;
      var emptyNum = 3;
      if (paramsObj.empty == 1) {
        emptyNum = 3;
      }
      else {
        emptyNum = getRandom(3, 1);
      }
      return getCalculationModel(leftNum, rightNum, resultNum, symbol, emptyNum);
    }
  }

  //---------减法-----------//
  let getSubtractionList = function () {
    let numFormula = new Object();//数式
    numFormula["Data"] = [];
    for (var i = 0; i < paramsObj.total; i++) {
      //numFormula.push(getAddInfo());
      numFormula["Data"].push(getSubtraction());// = getAddInfo();
    }
    return numFormula
  }

  let getSubtraction = function () {
    var leftNum = getRandom(paramsObj.range, 1);
    var rightNum = getRandom(leftNum, 1);
    var resultNum = leftNum - rightNum;
    var symbol = 2;
    var emptyNum = 3;
    if (paramsObj.empty == 1) {
      emptyNum = 3;
    }
    else {
      emptyNum = getRandom(3, 1);
    }
    return getCalculationModel(leftNum, rightNum, resultNum, symbol, emptyNum);
  }
  //---------加减各半-----------//
  let getAddSubtractionHalfList = function () {
    let numFormula = new Object();//数式
    numFormula["Data"] = [];
    var addNum = Math.floor(paramsObj.total / 2);
    for (var i = 0; i < addNum; i++) {
      numFormula["Data"].push(getAddInfo());
    }
    var subtractionNum = paramsObj.total - addNum;
    for (var i = 0; i < addNum; i++) {
      numFormula["Data"].push(getSubtraction());
    }
    return numFormula
  }

  //---------加减随机-----------//
  let getAddSubtractionRandomList = function () {
    numFormula = new Object();//数式
    numFormula["Data"] = [];
    for (var i = 0; i < paramsObj.total; i++) {
      //numFormula.push(getAddInfo());
      var randomNum = getRandom(2, 1);
      if (randomNum == 1) {
        numFormula["Data"].push(getAddInfo());
      }
      else {
        numFormula["Data"].push(getSubtraction());
      }
    }
  }


  //---------乘法-----------//
  let getMultiplyList = function () {
    let numFormula = new Object();//数式
    numFormula["Data"] = [];
    for (var i = 0; i < paramsObj.total; i++) {
      numFormula["Data"].push(getMultiplyInfo());
    }
    return numFormula
  }

  let getMultiplyInfo = function () {
    var leftNum = getRandom(paramsObj.range, 0);
    var rightNum = getRandom(paramsObj.range, 0);
    var resultNum = leftNum * rightNum;
    var symbol = 3;
    var emptyNum = 3;
    if (paramsObj.empty == 1) {
      emptyNum = 3;
    }
    else {
      emptyNum = getRandom(3, 1);
    }
    return getCalculationModel(leftNum, rightNum, resultNum, symbol, emptyNum);
  }

  //---------除法-----------//
  let getDivisionList = function () {
    let numFormula = new Object();//数式
    numFormula["Data"] = [];
    for (var i = 0; i < paramsObj.total; i++) {
      numFormula["Data"].push(getDivisionInfo());
    }
    return numFormula
  }

  let getDivisionInfo = function () {
    if (paramsObj.range == 10) {
      var rightNum = getRandom(paramsObj.range - 1, 1);
      var resultNum = getRandom(paramsObj.range - 1, 1);
      var leftNum = resultNum * rightNum;
      var symbol = 4;
      var emptyNum = 3;
      if (paramsObj.empty == 1) {
        emptyNum = 3;
      }
      else {
        emptyNum = getRandom(3, 1);
      }
      return getCalculationModel(leftNum, rightNum, resultNum, symbol, emptyNum);
    }
    else {
      var resultNum = getRandom(paramsObj.range, 1);
      var rightNum = getRandom(paramsObj.range, 1);
      var leftNum = resultNum * rightNum;
      var symbol = 4;
      var emptyNum = 3;
      if (paramsObj.empty == 1) {
        emptyNum = 3;
      }
      else {
        emptyNum = getRandom(3, 1);
      }
      return getCalculationModel(leftNum, rightNum, resultNum, symbol, emptyNum);
    }
  }


    //---------乘除各半-----------//
    let getDivisionMultiplyList = function () {
      let numFormula = new Object();//数式
      numFormula["Data"] = [];
      var addNum = Math.floor(paramsObj.total / 2);
      for (var i = 0; i < addNum; i++) {
        numFormula["Data"].push(getMultiplyInfo());
      }
      var subtractionNum = paramsObj.total - addNum;
      for (var i = 0; i < addNum; i++) {
        numFormula["Data"].push(getDivisionInfo());
      }
      return numFormula
    }

  /**
   * 开始计算
   */
  if(paramsObj.type == 'jia'){
    return getAddInfoList()
  }
  if(paramsObj.type == 'jian'){
    return getSubtractionList()
  }
  if(paramsObj.type == 'cheng'){
    return getMultiplyList()
  }
  if(paramsObj.type == 'chu'){
    return getDivisionList()
  }
  if(paramsObj.type == 'jia_jian'){
    return getAddSubtractionHalfList()
  }
  if(paramsObj.type == 'cheng_chu'){
    return getDivisionMultiplyList()
  }
}